

1. The current version has minimal third-party dependencies:

    ```bash
    pip install SQLAlchemy # Utilized for data caching.
    pip install scikit-learn # Employed for computing evaluation metrics.
    pip install loguru # logging functionalities.
    ```

2. we utilizes [vLLM](https://github.com/vllm-project/vllm) to launch inference services, currently supporting version >= 0.2.1.

    ```bash
    pip install vllm
    ```

    or build from source:
    ```bash
    git clone https://github.com/vllm-project/vllm.git
    cd vllm
    pip install -e .
    ```

1. Launching vLLM server for Fennec evaluation:

    ```bash
    python scripts/run_vllm_server.sh
    ```
    > + EVAL_PARALLEL: allows for inference on multiple GPU resources concurrently when available. 
    > + MODEl_NAME: the address where the downloaded model is stored.
2. Evaluating benchmark dataset (or custom dataset):
    ```bash
    python scripts/fennec_eval.sh
    ```
    > -a -p {number}: execute parallel inference and specify the {number}.